<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETicketItineraryInfo ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfETicketItineraryInfo extends AbstractStructArrayBase
{
    /**
     * The ETicketItineraryInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgETicketItineraryInfo[]
     */
    public $ETicketItineraryInfo;
    /**
     * Constructor method for ArrayOfETicketItineraryInfo
     * @uses DgArrayOfETicketItineraryInfo::setETicketItineraryInfo()
     * @param \dgsoft\StructType\DgETicketItineraryInfo[] $eTicketItineraryInfo
     */
    public function __construct(array $eTicketItineraryInfo = array())
    {
        $this
            ->setETicketItineraryInfo($eTicketItineraryInfo);
    }
    /**
     * Get ETicketItineraryInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgETicketItineraryInfo[]|null
     */
    public function getETicketItineraryInfo()
    {
        return isset($this->ETicketItineraryInfo) ? $this->ETicketItineraryInfo : null;
    }
    /**
     * Set ETicketItineraryInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgETicketItineraryInfo[] $eTicketItineraryInfo
     * @return \dgsoft\ArrayType\DgArrayOfETicketItineraryInfo
     */
    public function setETicketItineraryInfo(array $eTicketItineraryInfo = array())
    {
        foreach ($eTicketItineraryInfo as $arrayOfETicketItineraryInfoETicketItineraryInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfETicketItineraryInfoETicketItineraryInfoItem instanceof \dgsoft\StructType\DgETicketItineraryInfo) {
                throw new \InvalidArgumentException(sprintf('The ETicketItineraryInfo property can only contain items of \dgsoft\StructType\DgETicketItineraryInfo, "%s" given', is_object($arrayOfETicketItineraryInfoETicketItineraryInfoItem) ? get_class($arrayOfETicketItineraryInfoETicketItineraryInfoItem) : gettype($arrayOfETicketItineraryInfoETicketItineraryInfoItem)), __LINE__);
            }
        }
        if (is_null($eTicketItineraryInfo) || (is_array($eTicketItineraryInfo) && empty($eTicketItineraryInfo))) {
            unset($this->ETicketItineraryInfo);
        } else {
            $this->ETicketItineraryInfo = $eTicketItineraryInfo;
        }
        return $this;
    }
    /**
     * Add item to ETicketItineraryInfo value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgETicketItineraryInfo $item
     * @return \dgsoft\ArrayType\DgArrayOfETicketItineraryInfo
     */
    public function addToETicketItineraryInfo(\dgsoft\StructType\DgETicketItineraryInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgETicketItineraryInfo) {
            throw new \InvalidArgumentException(sprintf('The ETicketItineraryInfo property can only contain items of \dgsoft\StructType\DgETicketItineraryInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ETicketItineraryInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgETicketItineraryInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgETicketItineraryInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgETicketItineraryInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgETicketItineraryInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgETicketItineraryInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETicketItineraryInfo
     */
    public function getAttributeName()
    {
        return 'ETicketItineraryInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfETicketItineraryInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
